.TH XLETTERS 6 "11 SEP 1998"
.SH NAME
xletters \- catch falling words
.SH SYNOPSIS
.B xletters
[
.I options
]
.SH DESCRIPTION
.PP
.I X Letters
is a game under X to improve your typing skill.  It is inspired by
the game
.IR letters (6)
by Larry Moss and Brent Nordquist (which itself is inspired
by the game
.IR "Letter Invaders" ,
and ultimately by the famous
.IR "Space Invaders" ).
.PP
The goal of the game is to destroy the words that fall down from
the top before they reach the bottom.  To destroy a word, you
must simply type it.
.PP
The game is organized in levels of increasing difficulty.  Each
level is divided into two parts: a normal part and a bonus part.
During the normal part, ordinary english words will fall down
(found in the system's dictionary, usually
.BR /usr/dict/words ).
During the bonus part, the words are randomly generated from
printable ascii characters.
.PP
If a word hits the ground during the normal part, you lose a life
(you have five lives initially), and the word disappears
(but the others keep on falling).  If a word hits the ground during
the bonus part, the bonus part simply ends, with no additional
penalty, and the game proceeds to the next level.
.PP
The normal part of a level ends when a certain time has elapsed.  The
bonus part ends when either a certain time has elapsed or when a word
has hit the ground.  The normal duration of a half-level is 600 time
units, or 45 seconds (whatever the level).
.PP
Typing a word correctly makes the word disappear and scores you one
point per letter, plus five more points, plus another extra three
points if the word was destroyed in the top fifth of the window.
This is the only way of gaining points: partially typed words are not
worth anything, and even moving to another level doesn't bring you
points (this is because even if you don't type
.I anything
you will go beyond the first level).
.PP
Short words fall faster than long ones.  Unless otherwise specified
at compile time, words are not allowed to collide into one another.
Therefore, when a new word appears, the game makes sure that all
the words below it fall at least as fast as it.  The fall rate of the
words also increases with the level (it is, however, the same between
the normal part and the bonus part of the same level).  The rate at
which words appear is constant on a given level, but it increases with
the level.
.PP
A word is considered typed when the last printable characters that you
typed since the word appeared are precisely the letters of the word.
This means in particular that it is possible to ``kill two birds with
one stone'' if one word ends with the letters with which another one
begins - in fact, if two identical words appear (an unlikely but not
impossible situation), you need only type one of them.  To say things
differently, if you type a correct letter it will make your position
in the word advance by one letter, and if you type an incorrect
letter, it will make your position move back to the last place in the
word that matches the characters you typed.  The current position in
each word is indicated by putting the already typed letters in a
different color (normally red).  Note that a different behaviour is
selectable at compile time with which a wrong letter will cause all
letters to be considered wrong (to make the difference obvious,
consider the word ``abracadabrx'': if after having typed
``abracadabr'' you press an ``a'', the normal behaviour will take you
back to ``abra'' whereas the alternate behaviour will take you back to
the beginning).
.PP
The game keeps a high score table.  When the game is over, one way or
another, xletters will show, for the user and for the twenty best
players, the name, the level reached, the final score, and the time
during which the game was running.  Normally, each player is allowed
only one entry in the high score table.  This can be modified at
compilation time, however.
.SH CONTROLS
.PP
The top of the window shows two buttons.  The
.B Quit
button will take you out of the game, and the
.B Pause
button will pause the game or resume it if it was already paused.
These buttons can also be accessed through accelerators: the
``Escape'' key will quit the game, and the ``Tab'' key (or ``Pause''
if you have one) will suspend it or resume it.
.PP
Three labels on the right of the buttons are used to indicate
your lives, score and current level.
.PP
Other than that, to play the game you must simply type the words.
In order for the typing to be effective, your mouse cursor must
be in the game space (the large square area below the buttons and
labels).  If you start typing while the game is paused, it will
automatically resume.
.SH OPTIONS
.PP
.I X Letters
recognizes all the standard X Toolkit command line options,
among which the following:
.TP
.BI \-bg " color"
Specifies the background color to use.
.TP
.BI \-fg " color"
Specifies the foreground color to use for the labels and buttons.
.TP
.BI \-fn " font"
Specifies the font to use for displaying the labels and buttons.
.TP
.BI \-name " name"
Specifies the application name under which resources
are to be obtained, rather than under the default
executable file name.
.I name
should not contain ``.'' or ``*'' characters.
.TP
.BI \-title " string"
Specifies the window title string.
.TP
.BI \-geometry " geometry"
Specifies the preferred position of the window.
Specifying a size is not recommended.
.TP
.BI \-display " display"
Specifies the X server to use.
.TP
.BI \-xrm " resourcestring"
Explicitely give a resource string.
.PP
The following additional options are recognized by
.IR xletters :
.TP
.BI \-wfn " font"
Specifies the font to use for the falling words.
.TP
.BI \-wc " color"
Specifies which color to use for the words.
.TP
.BI \-tc " color"
Specifies which color to use for the correctly typed part
of the words.
.TP
.BI \-gbg " color"
Specifies which color to use for the background of the game
space.
.PP
In addition,
.I xletters
recognizes
.BR \-help " and " \-version
options.
.SH WIDGETS
.TP
.B "groundBox (\fPclass\fB Box, \fPparent\fB \fP(toplevel)\fB)"
This is the main application box that supports all the
other widgets.
.TP
.B "label (\fPclass\fB Label, \fPparent\fB groundBox)"
The
.I xletters
label.  The text of this label cannot be changed.
.TP
.B "quitButton (\fPclass\fB Command, \fPparent\fB groundBox)"
The
.B Quit
button.
.TP
.B "pauseButton (\fPclass\fB Toggle, \fPparent\fB groundBox)"
The
.B Pause
button.
.TP
.B "livesLabel (\fPclass\fB Label, \fPparent\fB groundBox)"
The lives label.
.TP
.B "scoreLabel (\fPclass\fB Label, \fPparent\fB groundBox)"
The score label.
.TP
.B "levelLabel (\fPclass\fB Label, \fPparent\fB groundBox)"
The level label.
.TP
.B "gameSpace (\fPclass\fB Core, \fPparent\fB groundBox)"
The game space in which the words fall.  Key presses and Expose events
are handled through event handlers and not the ordinary translation/action
mechanism.
.SH FILES
.PP
(If not overriden at compile time)
.TP
.B /usr/dict/words
The dictionary of words.
.TP
.B /var/local/games/lib/xletters/scores
The high score table.
.SH "CONFIGURATION SUGGESTION"
.PP
xletters
\-wfn '\-bitstream\-terminal\-medium\-r\-normal\-\-18\-*\-*\-*\-c\-*\-iso8859\-1'
\-gbg 'MidnightBlue'
\-wc 'PaleGoldenrod'
\-tc 'Orchid'
.SH BUGS
.PP
None known.  Surely a very temporary situation :-)
.PP
This is one of the ugliest programs I ever wrote.  I would not be surprized
to discover plenty of bugs in it, notably in: the high score table handling
parts, the collision-avoidance algorithm, and the determination of what part
of a word has been pressed.
.SH SECURITY
.PP
.I xletters
wants to access a high score table.  If this score table is to be shared
between several users,
.I xletters
will probably be made sgid games or some such thing.  Beware that
it is probably very easy to fool (or even brake to pieces).  I have
no doubt that running it against a fake X server (and probably other
similar things) can give not-too-hard access to whatever permissions
it has been given.  Consequently, it should not be given any critical
permissions.
.SH AUTHORS
.PP
David Madore (david.madore@ens.fr)
.PP
Special thanks to Peter Horvai (as always).
.SH COPYING
GNU public license.  See the file
.B COPYING
for more information.
.SH "SEE ALSO"
.BR letters "(6), " xtetris (6)
